import * as METADATA from './constants';
import { Config as InjectConfig } from './decorator/inject';

export type ClassConstructor<T> = {new(...args: any[]): T};

class AppContext {
  private static context: AppContext = null;
  private instanceMap: Map<symbol, Function>;

  private constructor() {
    this.instanceMap = new Map();
  }

  public put(instance: any, name?: string): void {
    let aaa = Object.getPrototypeOf(instance);
    if (typeof name !== 'string') {
      if (instance.constructor !== undefined) {
        name = instance.constructor.name;
      }
    }
    this.instanceMap.set(aaa, instance);
  }

  private setValue(type: Function, target: object): void {
    if (type.constructor === Object) {
      console.log('Object');
      return;
    }

    let meta: Map<string | symbol, InjectConfig> = Reflect.getMetadata(METADATA.INJECT_TAG, type);
    if (undefined !== meta) {
      let property: any;
      meta.forEach((config, key, map) => {
        property = Object.getOwnPropertyDescriptor(type, key);

        let dddd = this.instanceMap.get(config.type);
        target[key] = dddd;
        console.log(dddd);
      });
    }


    this.setValue(Object.getPrototypeOf(type), target);
  }

  public static getService<T>(type: ClassConstructor<T>, ...args: any[]): T {
    let clazz: Function = type.prototype;
    let instance = Object.create(clazz);
    instance.constructor.apply(instance, args);

    AppContext.getContext().setValue(clazz, instance);
    return instance;
  }

  public static get<T>(): T {


    return null;
  }

  public static put(instance: any, name?: string): void {
    AppContext.getContext().put(instance, name);
  }

  public static getContext(): AppContext {
    if (null === AppContext.context) {
      AppContext.context = new AppContext();
    }
    return AppContext.context;
  }

  public static destroy(): void {
    console.log('AppContext has been destroyed.');
  }

}

export default AppContext;
