import * as METADATA from '../constants';
import PouchDefinition from '../config/PouchDefinition';

const Qualifier = (value: string | symbol) => {
  return <TFunction extends Function>(target: TFunction): TFunction | void => {
    if (Reflect.hasOwnMetadata(METADATA.POUCH_DEFINITION, target) !== true) {
      throw new Error('Cannot apply @Qualifier decorator on the not @Injectable class.');
    }
    let pouchDefinition: PouchDefinition = Reflect.getMetadata(METADATA.POUCH_DEFINITION, target);
    pouchDefinition.qualifier = value;

    return target;
  };
};

export default Qualifier;
