import * as METADATA from '../constants';
import PouchDefinition from '../config/PouchDefinition';
import { PouchScope } from '../constants';

const Scope = (value: PouchScope = PouchScope.SINGLETON) => {
  return <TFunction extends Function>(target: TFunction): TFunction | void => {
    if (Reflect.hasOwnMetadata(METADATA.POUCH_DEFINITION, target) !== true) {
      throw new Error('Cannot apply @Scope decorator on the not @Injectable class.');
    }
    let pouchDefinition: PouchDefinition = Reflect.getMetadata(METADATA.POUCH_DEFINITION, target);
    pouchDefinition.scope = value;

    return target;
  };
};

export default Scope;
