import * as React from 'react';
import {
  Button,
  Table,
  Label,
  Segment,
  Header,
  Container,
} from 'semantic-ui-react';
import Probe from '@overflow/probe/api/model/Probe';
import { Discovery } from '../../../discovery/react/components/Discovery';

export interface StateProps {
  id: string;
}

export interface DispatchProps {
  onDiscoveryClick(id:string):void;
}

export type Props = StateProps & DispatchProps;

export interface State {
  probe: any; // todo. fix to Probe
  // isDiscovery: boolean;
}


export class ProbeDetailInfo extends React.Component<Props, State> {

  constructor(props: Props, context: State) {
    super(props, context);
    this.state = {
      probe: null,
      // isDiscovery: false,
    };
  }

  public componentWillMount(): void {

    // todo. getting probe by probeId
    let p = {
      'id': '11',
      'status': {
        'name': 'INITIAL',
      },
      'domain': {
        'name': 'insanity\'s domain',
      },
      'cidr': '192.168.1.0/24',
      'displayName': '192.168.1.105\'s probe',
      'infraHost': {
        'ip': '192.168.1.105',
        'mac': 'ab:cd:ef:gh:ij',
      },
      'targetCount': '20',
      'sensorCount': '30',
      'probeKey': '1AGBLKDFJ2452ASDGFL2KWJLKSDJ',
      'description': 'description1111111111',
      'createDate': '2017-01-01',
      'authorizeDate': '2017-01-01',
      'restartDate': '2017-01-01',
      'authorizeMember': {
        'name': 'insanity',
      },
    };

    this.setState({
      probe: p,
      // isDiscovery: false,
    });
  }

  public handleStartStop(event: any, data: any): void {
    console.log(event);
  }

  public handleDiscovery = (event: any, data: any): void => {
    console.log(event);
    // this.setState({ isDiscovery: true });
    this.props.onDiscoveryClick('11');
  }

  // public renderDiscovery(): JSX.Element {
  //   if (this.state.isDiscovery) {
  //     return <Discovery />;
  //   }
  //   return null;
  //
  // }

  public showStopBtn(): JSX.Element {
    if (this.state.probe.status.name === 'NORMAL') {
      return <Button content='Stop' icon='stop' labelPosition='left' negative />;
    }
  }

  public render(): JSX.Element {
    return (
      <Container fluid>
        <Table celled={false} >
          <Table.Body>
            <Table.Row>
              <Table.Cell collapsing>
                <Header size='small'>Name</Header>
              </Table.Cell>
              <Table.Cell>{this.state.probe.displayName}</Table.Cell>
            </Table.Row>
            <Table.Row>
              <Table.Cell collapsing>
                <Header size='small'>Status</Header>
              </Table.Cell>
              <Table.Cell>{this.state.probe.status.name}</Table.Cell>
            </Table.Row>
            <Table.Row>
              <Table.Cell collapsing>
                <Header size='small'>Created at</Header>
              </Table.Cell>
              <Table.Cell>{this.state.probe.createDate}</Table.Cell>
            </Table.Row>
            <Table.Row>
              <Table.Cell collapsing>
                <Header size='small'>Authorized at</Header>
              </Table.Cell>
              <Table.Cell>{this.state.probe.authorizeDate}</Table.Cell>
            </Table.Row>
            <Table.Row>
              <Table.Cell collapsing>
                <Header size='small'>Authorized by</Header>
              </Table.Cell>
              <Table.Cell>{this.state.probe.authorizeMember.name}</Table.Cell>
            </Table.Row>
            <Table.Row>
              <Table.Cell collapsing>
                <Header size='small'>Uptime</Header>
              </Table.Cell>
              <Table.Cell>todo.</Table.Cell>
            </Table.Row>
            <Table.Row>
              <Table.Cell collapsing>
                <Header size='small'>Description</Header>
              </Table.Cell>
              <Table.Cell>{this.state.probe.description}</Table.Cell>
            </Table.Row>
          </Table.Body>
        </Table>
        {this.showStopBtn()}
        <Button content='Discovery' icon='search' labelPosition='left' floated={'right'} positive onClick={this.handleDiscovery} />
        {/*{this.renderDiscovery()}*/}
      </Container>
    );
  }

}

